//===================================================================
// Apci8394s.pas
//-------------------------------------------------------------------
// aPCI-8394
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
unit Apci8394s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Apci8394w;

const
	szTitle			= 'Sample';
	szApci8394 	= 'aPCI-8394';

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
		procedure ResultMessage(strbuf:String);
		procedure ErrorMessage(wLogSlot:Word);

  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
var
	strbuf:		String;
	wLogSlot:	Word;
	dwDllVer:	DWord;
	dwDrvVer:	DWord;
	ri:				TAPCI8394RESOURCE;
	wData:		Word;
	i:				Integer;
	wSat:			Word;
begin
	//-----------------------------------------------------------------
	// Apci8394.dll J
	//-----------------------------------------------------------------
	if Apci8394wDllOpen() = False then begin
		ErrorMessage( APCI8394_SLOT_AUTO );
		Halt;
	end;
	//-----------------------------------------------------------------
	// o[W\
	//-----------------------------------------------------------------
	if Apci8394wGetVersion(dwDllVer,dwDrvVer) = False then begin
		ErrorMessage( APCI8394_SLOT_AUTO );
		Halt;
	end;
	strbuf:= Format(
						'GetVersion'#10+
						'Dll Version:%08xH'#10+
						'Drv Version:%08xH', [dwDllVer,dwDrvVer]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
  // foCX̎gp錾
	//-----------------------------------------------------------------
	wLogSlot:=APCI8394_SLOT_AUTO; // 󂫃foCXw
	if Apci8394wCreate( wLogSlot ) = False then begin
		ErrorMessage( APCI8394_SLOT_AUTO );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8394 Created'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	if Apci8394wGetResource( wLogSlot, @ri ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8394 Resource'#10+
			'PortAdr:%04xH - %04xH',
			[ri.dwIOPortBase[1],ri.dwIOPortBase[1]+ri.dwIOPortLength[1]-1]);
	ResultMessage(strbuf);

	///// gkr^pO /////

	//-----------------------------------------------------------------
	// TeCg
	//-----------------------------------------------------------------
	wSat := 3; // TeCgR
	strbuf:=Format(
		'TeCg %d ɐݒ肵܂',[wSat]);
	ResultMessage(strbuf);

	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Apci8394wInitialize( wLogSlot ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage('foCX܂');

	//-----------------------------------------------------------------
	// STeCgɑΉRg[GAɃ[ݒ
	//-----------------------------------------------------------------
	for i := 1 to wSat do begin
		if Apci8394wCtrlWrite( wLogSlot, i, 0 ) = False then begin
			ErrorMessage( wLogSlot );
			Halt;
		end;
	end;
	ResultMessage('Rg[GAɃ[ݒ肵܂');

	//-----------------------------------------------------------------
	// ^p݁i^pJnj
	//-----------------------------------------------------------------
	if Apci8394wStart( wLogSlot, wSat ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf := Format(
		'^p %d łgkr^pJn܂',[wSat]);
	ResultMessage(strbuf);

	///// ^p̏ /////

	//-----------------------------------------------------------------
	// TeCgԍPɑΉ DiGA̓ǂݍ
	//-----------------------------------------------------------------
	if Apci8394wDin( wLogSlot, 1, wData ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf := Format(
		'TeCg %d ɑΉDiGA̒l = %Xh',[1,wData] );
	ResultMessage(strbuf);

	//-----------------------------------------------------------------
	// TeCgԍPɑΉ DoGAɒl
	//-----------------------------------------------------------------
	wData:=$AAAA;
	if Apci8394wDout( wLogSlot, 1, wData ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf := Format(
		'TeCg %d ɑΉDoGA %Xh݂܂',[1,wData] );
	ResultMessage(strbuf);

	///// ^p~ /////

	//-----------------------------------------------------------------
	// ^p~
	//-----------------------------------------------------------------
	if Apci8394wStop(wLogSlot) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage('gkr̉^p~܂');

	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Apci8394wClose( wLogSlot ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8394 Close'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	Halt;

end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Apci8394wDllClose();
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage(strbuf:String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage(wLogSlot:Word);
var
	dwRes:	DWord;
	strbuf:	String;
begin
	dwRes:=Apci8394wGetLastError(wLogSlot);
	if dwRes = APCI8394_ERR_WRAPDLL then begin
		strbuf:='DLL Load error';
	end else begin
		strbuf:=Format(
							'aPCI8394 error'#10#10'Error code:%08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
