//===================================================================
// Apci8394w.pas
//-------------------------------------------------------------------
// aPCI-8394
//
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
unit Apci8394w;

interface

uses
	Windows;

const

	// DLL Name
	APCI8394_DLL_NAME								= 'Apci8394.dll';

	// Error code
	APCI8394_SUCCESS								= 0;	// ُȂiIj
	APCI8394_ERR_SYSTEM							=	1;	// VXeG[
	APCI8394_ERR_NO_DEVICE					= 2;	// gp\ȃfoCX܂
	APCI8394_ERR_IN_USE							=	3;	// w̃foCX͎gpł
	APCI8394_ERR_INVALID_SLOT				=	4;	// Ș_Xbgł
	APCI8394_ERR_RESOURCE						=	5;	// \[XG[
	APCI8394_ERR_INVALID_PORT				=	6;	// sȃ|[gv
	APCI8394_ERR_INVALID_ARG				=	7;	// sȈv܂
	APCI8394_ERR_PORT								= 8;  // ȃ|[gł
	APCI8394_ERR_INVALID_ADR				= 9;  // ȃAhXł
	APCI8394_ERR_BUSY								= 10; // ^pł

	// Misc
	APCI8394_SLOT_AUTO							= $FFFF;
	APCI8394_MAX_SLOTS							= 16;
	APCI8394_ERR_WRAPDLL						= DWord(-1);

	// Memory map ( Word access )
	APCI8394_MEM_CMD								= $0000;
	APCI8394_MEM_DO									= $0080;
	APCI8394_MEM_DI									= $0100;
	APCI8394_MEM_C1									= $0180;
	APCI8394_MEM_C2									= $0200;
	APCI8394_MEM_C3									= $0280;
	APCI8394_MEM_C4									= $0300;
	APCI8394_MEM_C5									= $0380;
	APCI8394_MEM_C6									= $0400;
	APCI8394_MEM_DATA								= $0480;

	// Command
	APCI8394_CMD_DI_READ						= 0;
	APCI8394_CMD_COUNTER1_READ			= 1;
	APCI8394_CMD_COUNTER2_READ			= 2;
	APCI8394_CMD_COUNTER3_READ			= 3;
	APCI8394_CMD_COUNTER4_READ			= 4;
	APCI8394_CMD_COUNTER5_READ			= 5;
	APCI8394_CMD_COUNTER6_READ			= 6;
	APCI8394_CMD_DATA_REG_READ			= 7;
	APCI8394_CMD_COUNTER1_CLEAR			= 9;
	APCI8394_CMD_COUNTER2_CLEAR			= 10;
	APCI8394_CMD_COUNTER3_CLEAR			= 11;
	APCI8394_CMD_COUNTER4_CLEAR			= 12;
	APCI8394_CMD_COUNTER5_CLEAR			= 13;
	APCI8394_CMD_COUNTER6_CLEAR			= 14;

	// Resource information
	APCI8394_MAX_MEM								= 9;
	APCI8394_MAX_IO									= 20;
	APCI8394_MAX_IRQ								= 7;
	APCI8394_MAX_DMA								= 7;

type
	TAPCI8394RESOURCE = record
		dwNumMemWindows:																	DWord;	{ س޳(gp) }
		dwMemBase:			array [1 .. APCI8394_MAX_MEM] of	DWord;	{ س޳ްڽ(gp) }
		dwMemLength:		array [1 .. APCI8394_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwMemAttrib:		array [1 .. APCI8394_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwNumIOPorts:																			DWord;	{ I/O߰Đ }
		dwIOPortBase:		array [1 .. APCI8394_MAX_IO] 	of	DWord;	{ I/O߰ްڽ }
		dwIOPortLength: array [1 .. APCI8394_MAX_IO] 	of	DWord;	{ I/O߰Ē }
		dwNumIRQs:																				DWord;	{ IRQ(gp) }
		dwIRQRegisters: array [1 .. APCI8394_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwIRQAttrib:		array [1 .. APCI8394_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwNumDMAs:																				DWord;	{ DMAِ(gp) }
		dwDMALst:				array [1 .. APCI8394_MAX_DMA] of	DWord;	{ DMAؽ(gp) }
		dwDMAAttrib:		array [1 .. APCI8394_MAX_DMA] of	DWord;	{ DMAّؽ(gp) }
		dwReserved1:		array [1 .. 3] of									DWord;	{ \(gp) }
	end;

PAPCI8394R=^TAPCI8394RESOURCE;

//DLL [h
function Apci8394wDllOpen:Boolean;
//DLL A[h
function Apci8394wDllClose:Boolean;
//o[Wԍ擾
function Apci8394wGetVersion(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;
//foCX̎gp錾
function Apci8394wCreate(var pwLogSlot:Word):Boolean;
//foCX̊J
function Apci8394wClose(wLogSlot:Word):Boolean;
//\[X擾
function Apci8394wGetResource(wLogSlot:Word;pres:PAPCI8394R):Boolean;
//G[R[h擾
function Apci8394wGetLastError(wLogSlot:Word):DWord;
//[h
function Apci8394wInpw( wLogSlot,wPort:Word; var pwData:Word ):Boolean;
//[ho
function Apci8394wOutpw( wLogSlot,wPort,wData:Word ):Boolean;
//gkrǂݍ
function Apci8394wMemRead( wLogSlot,wAdr:Word; var pwData:Word ):Boolean;
//gkr
function Apci8394wMemWrite( wLogSlot,wAdr,wData:Word ):Boolean;
//gkr
function Apci8394wInitialize( wLogSlot:Word ):Boolean;
//gkrʐMVXeJn
function Apci8394wStart( wLogSlot, wSNum:Word ):Boolean;
//gkrʐMVXe~
function Apci8394wStop( wLogSlot:Word ):Boolean;
//cGÃAhXɏݎs
function Apci8394wDout( wLogSlot, wSNo, wData:Word ):Boolean;
//cGA̒lǂݍ
function Apci8394wDin( wLogSlot,wSNo:Word; var pwData:Word ):Boolean;
//JE^GA̒lǂݍ
function Apci8394wCntRead( wLogSlot,wSNo,wCntNo:Word; var pwData:Word ):Boolean;
//f[^WX^GA̒lǂݍ
function Apci8394wDRegRead( wLogSlot, wSNo:Word; var pwData:Word ):Boolean;
//Rg[GAɃR}h
function Apci8394wCtrlWrite( wLogSlot, wSNo, wCmd:Word ):Boolean;
//Rg[GAǂݍ
function Apci8394wCtrlRead( wLogSlot, wSNo:Word; var pwValue:Word ):Boolean;

implementation

type
	TApci8394GetVersion		=function(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;stdcall;
	TApci8394Create				=function(var pwLogSlot:Word):Boolean;stdcall;
	TApci8394Close				=function(wLogSlot:Word):Boolean;stdcall;
	TApci8394GetResource  =function(wLogSlot:Word;pres:PAPCI8394R):Boolean;stdcall;
	TApci8394GetLastError	=function(wLogSlot:Word):Word;stdcall;

	TApci8394Inpw					=function( wLogSlot,wPort:Word; var pwData:Word ):Boolean;stdcall;
	TApci8394Outpw				=function( wLogSlot,wPort,wData:Word ):Boolean;stdcall;
	TApci8394MemRead			=function( wLogSlot,wAdr:Word; var pwData:Word ):Boolean;stdcall;
	TApci8394MemWrite			=function( wLogSlot,wAdr,wData:Word ):Boolean;stdcall;
	TApci8394Initialize		=function( wLogSlot:Word ):Boolean;stdcall;
	TApci8394Start				=function( wLogSlot, wSNum:Word ):Boolean;stdcall;
	TApci8394Stop					=function( wLogSlot:Word ):Boolean;stdcall;
	TApci8394Dout					=function( wLogSlot, wSNo, wData:Word ):Boolean;stdcall;
	TApci8394Din					=function( wLogSlot,wSNo:Word; var pwData:Word ):Boolean;stdcall;
	TApci8394CntRead			=function( wLogSlot,wSNo,wCntNo:Word; var pwData:Word ):Boolean;stdcall;
	TApci8394DRegRead			=function( wLogSlot, wSNo:Word; var pwData:Word ):Boolean;stdcall;
	TApci8394CtrlWrite		=function( wLogSlot, wSNo, wCmd:Word ):Boolean;stdcall;
	TApci8394CtrlRead			=function( wLogSlot, wSNo:Word; var pwValue:Word ):Boolean;stdcall;


function Apci8394wGetDllExportFunc:Boolean;forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

// DLLGNX|[g֐AhX̊i[ϐ
var
	pApci8394GetVersion:		TApci8394GetVersion;
	pApci8394Create:				TApci8394Create;
	pApci8394Close:					TApci8394Close;
	pApci8394GetResource:		TApci8394GetResource;
	pApci8394GetLastError:	TApci8394GetLastError;
	pApci8394Inpw:					TApci8394Inpw;
	pApci8394Outpw:					TApci8394Outpw;
	pApci8394MemRead:				TApci8394MemRead;
	pApci8394MemWrite:			TApci8394MemWrite;
	pApci8394Initialize:		TApci8394Initialize;
	pApci8394Start:					TApci8394Start;
	pApci8394Stop:					TApci8394Stop;
	pApci8394Dout:					TApci8394Dout;
	pApci8394Din:						TApci8394Din;
	pApci8394CntRead:				TApci8394CntRead;
	pApci8394DRegRead:			TApci8394DRegRead;
	pApci8394CtrlWrite:			TApci8394CtrlWrite;
	pApci8394CtrlRead:			TApci8394CtrlRead;


//===================================================================
//   	Apci8394.dll [h
//   	
// ߂l  True
//				s False
//===================================================================
function Apci8394wDllOpen:Boolean;
begin
	Result:=False;
	if hDLL <> 0 then Exit;
	hDLL := LoadLibrary(APCI8394_DLL_NAME);
	if hDLL = 0 then Exit;
	if Apci8394wGetDllExportFunc = False then	begin
		Apci8394wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;
	Result := True;
end;
//===================================================================
//   	Apci8394.dllA[h
//   	
// ߂l  True
//				s False
//===================================================================
function Apci8394wDllClose: Boolean;
begin
	Result := True;
	if hDLL = 0 then Exit;
	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;
//===================================================================
//    o[Wԍ擾
//    pdwDllVer	DLLo[Wԍi[
//        pdwDrvVer	DRVo[Wԍi[
// ߂l  True
//				s False
//===================================================================
function Apci8394wGetVersion(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394GetVersion(pdwDllVer,pdwDrvVer);
end;
//===================================================================
//    foCX̎gp錾
//    pwLogSlot gpfoCXi[
// ߂l  True
//				s False
//===================================================================
function Apci8394wCreate(var pwLogSlot:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Create(pwLogSlot);
end;
//===================================================================
//    foCX̊J
//    wLogSlot	gpfoCX
// ߂l  True
//				s False
//===================================================================
function Apci8394wClose(wLogSlot:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Close(wLogSlot);
end;
//===================================================================
//    wfoCX̃\[X擾
//    wLogSlot	foCX
//        pres			\[Xi[\
// ߂l  True
//				s False
//===================================================================
function Apci8394wGetResource(wLogSlot:Word;pres:PAPCI8394R):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394GetResource(wLogSlot,pres);
end;
//===================================================================
//    [h
//    wLogSlot	foCX
//				wPort			|[gԍ
//				pwData		̓f[^i[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Apci8394wInpw( wLogSlot,wPort:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Inpw(wLogSlot,wPort,pwData);
end;
//===================================================================
//    [ho
//    wLogSlot	foCX
//				wPort			|[gԍ
//				wData			o̓f[^
// ߂l  True
//				s False
//===================================================================
function Apci8394wOutpw( wLogSlot,wPort,wData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Outpw(wLogSlot,wPort,wData);
end;
//===================================================================
//    gkrǂݍ
//    wLogSlot	foCX
//				wAdr			AhX
//				pwData    ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Apci8394wMemRead( wLogSlot,wAdr:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394MemRead(wLogSlot,wAdr,pwData);
end;
//===================================================================
//    gkr
//    wLogSlot	foCX
//				wAdr			AhX
//				wData			ޒl
// ߂l  True
//				s False
//===================================================================
function Apci8394wMemWrite( wLogSlot,wAdr,wData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394MemWrite(wLogSlot,wAdr,wData);
end;
//===================================================================
//    gkr
//    wLogSlot	foCX
// ߂l  True
//				s False
//===================================================================
function Apci8394wInitialize( wLogSlot:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Initialize(wLogSlot);
end;
//===================================================================
//    gkrʐMVXeJn
//    wLogSlot	foCX
//				wSNum			^pTeCg
// ߂l  True
//				s False
//===================================================================
function Apci8394wStart( wLogSlot, wSNum:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Start(wLogSlot,wSNum);
end;
//===================================================================
//    gkrʐMVXe~
//    wLogSlot	foCX
// ߂l  True
//				s False
//===================================================================
function Apci8394wStop( wLogSlot:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Stop(wLogSlot);
end;
//===================================================================
//    cGÃAhXɏݎs
//    wLogSlot	foCX
//				wSNo			TeCgm
//				wData			ޒl
// ߂l  True
//				s False
//===================================================================
function Apci8394wDout( wLogSlot, wSNo, wData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Dout(wLogSlot,wSNo,wData);
end;
//===================================================================
//    cGA̒lǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				pwData		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Apci8394wDin( wLogSlot,wSNo:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394Din(wLogSlot,wSNo,pwData);
end;
//===================================================================
//    JE^GA̒lǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				wCntNo		JE^ԍ(1`6)
//				pwData		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Apci8394wCntRead( wLogSlot,wSNo,wCntNo:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394CntRead(wLogSlot,wSNo,wCntNo,pwData);
end;
//===================================================================
//    f[^WX^GA̒lǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				pwData		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Apci8394wDRegRead( wLogSlot, wSNo:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394DRegRead(wLogSlot,wSNo,pwData);
end;
//===================================================================
//    Rg[GAɃR}h
//    wLogSlot	foCX
//				wSNo			TeCgm
//				wCmd			R}h
// ߂l  True
//				s False
//===================================================================
function Apci8394wCtrlWrite( wLogSlot, wSNo, wCmd:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394CtrlWrite(wLogSlot,wSNo,wCmd);
end;
//===================================================================
//    Rg[GAǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				pwValue		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Apci8394wCtrlRead( wLogSlot, wSNo:Word; var pwValue:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci8394CtrlRead(wLogSlot,wSNo,pwValue);
end;
//===================================================================
//    G[R[h擾
//    wLogSlot		foCX
// ߂l  True
//        s False
//===================================================================
function Apci8394wGetLastError(wLogSlot:Word):DWord;
begin
	Result := APCI8394_ERR_WRAPDLL;
	if hDLL = 0 then Exit;
	Result := pApci8394GetLastError(wLogSlot);
end;
//-------------------------------------------------------------------
//    DLLGNX|[g֐AhX̎擾
//    
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Apci8394wGetDllExportFunc:Boolean;
begin
	Result := False;

	pApci8394GetVersion			:= GetProcAddress(hDLL,'Apci8394GetVersion');
	if @pApci8394GetVersion		= nil then Exit;
	pApci8394Create					:= GetProcAddress(hDLL,'Apci8394Create');
	if @pApci8394Create 			= nil then Exit;
	pApci8394Close					:= GetProcAddress(hDLL,'Apci8394Close');
	if @pApci8394Close 				= nil then Exit;
	pApci8394GetResource		:= GetProcAddress(hDLL,'Apci8394GetResource');
	if @pApci8394GetResource 	= nil then Exit;
	pApci8394GetLastError		:= GetProcAddress(hDLL,'Apci8394GetLastError');
	if @pApci8394GetLastError	= nil then Exit;
	pApci8394Inpw						:= GetProcAddress(hDLL,'Apci8394Inpw');
	if @pApci8394Inpw					= nil then Exit;
	pApci8394Outpw					:= GetProcAddress(hDLL,'Apci8394Outpw');
	if @pApci8394Outpw					= nil then Exit;
	pApci8394MemRead				:= GetProcAddress(hDLL,'Apci8394MemRead');
	if @pApci8394MemRead				= nil then Exit;
	pApci8394MemWrite				:= GetProcAddress(hDLL,'Apci8394MemWrite');
	if @pApci8394MemWrite				= nil then Exit;
	pApci8394Initialize			:= GetProcAddress(hDLL,'Apci8394Initialize');
	if @pApci8394Initialize			= nil then Exit;
	pApci8394Start					:= GetProcAddress(hDLL,'Apci8394Start');
	if @pApci8394Start					= nil then Exit;
	pApci8394Stop						:= GetProcAddress(hDLL,'Apci8394Stop');
	if @pApci8394Stop						= nil then Exit;
	pApci8394Dout						:= GetProcAddress(hDLL,'Apci8394Dout');
	if @pApci8394Dout						= nil then Exit;
	pApci8394Din						:= GetProcAddress(hDLL,'Apci8394Din');
	if @pApci8394Din						= nil then Exit;
	pApci8394CntRead				:= GetProcAddress(hDLL,'Apci8394CntRead');
	if @pApci8394CntRead				= nil then Exit;
	pApci8394DRegRead				:= GetProcAddress(hDLL,'Apci8394DRegRead');
	if @pApci8394DRegRead				= nil then Exit;
	pApci8394CtrlWrite			:= GetProcAddress(hDLL,'Apci8394CtrlWrite');
	if @pApci8394CtrlWrite			= nil then Exit;
	pApci8394CtrlRead				:= GetProcAddress(hDLL,'Apci8394CtrlRead');
	if @pApci8394CtrlRead				= nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.
