Attribute VB_Name = "Apci8394"
'-----------------------------------------------------------------
' Apci8394.bas
' aPCI-8394 Win32 API.
'
' Copyright(C)ADTEK SYSTEM SCIECEN Co.,Ltd.
'-----------------------------------------------------------------
Option Explicit
'-----------------------------------------------------------------
' Error code
'-----------------------------------------------------------------
Global Const APCI8394_SUCCESS = 0                 ' ُȂiIj
Global Const APCI8394_ERR_SYSTEM = 1              ' VXeG[
Global Const APCI8394_ERR_NO_DEVICE = 2           ' gp\ȃfoCX܂
Global Const APCI8394_ERR_IN_USE = 3              ' w̃foCX͎gpł
Global Const APCI8394_ERR_INVALID_SLOT = 4        ' Ș_Xbgł
Global Const APCI8394_ERR_RESOURCE = 5            ' \[XG[
Global Const APCI8394_ERR_INVALID_PORT = 6        ' sȃ|[gv
Global Const APCI8394_ERR_INVALID_ARG = 7         ' sȈv܂
Global Const APCI8394_ERR_PORT = 8                ' ȃ|[gł
Global Const APCI8394_ERR_INVALID_ADR = 9         ' ȃAhXł
Global Const APCI8394_ERR_BUSY = 0                ' ^pł

'-----------------------------------------------------------------
' command
'-----------------------------------------------------------------
Global Const APCI8394_CMD_DI_READ = 0
Global Const APCI8394_CMD_COUNTER1_READ	= 1
Global Const APCI8394_CMD_COUNTER2_READ	= 2
Global Const APCI8394_CMD_COUNTER3_READ	= 3
Global Const APCI8394_CMD_COUNTER4_READ	= 4
Global Const APCI8394_CMD_COUNTER5_READ	= 5
Global Const APCI8394_CMD_COUNTER6_READ	= 6
Global Const APCI8394_CMD_DATA_REG_READ	= 7
Global Const APCI8394_CMD_COUNTER1_CLEAR = 9
Global Const APCI8394_CMD_COUNTER2_CLEAR = 10
Global Const APCI8394_CMD_COUNTER3_CLEAR = 11
Global Const APCI8394_CMD_COUNTER4_CLEAR = 12
Global Const APCI8394_CMD_COUNTER5_CLEAR = 13
Global Const APCI8394_CMD_COUNTER6_CLEAR = 14
'-----------------------------------------------------------------
' Misc
'-----------------------------------------------------------------
Global Const APCI8394_SLOT_AUTO = &HFFFF
Global Const APCI8394_MAX_SLOTS = 16
'-----------------------------------------------------------------
' Resoucer information
'-----------------------------------------------------------------
Global Const APCI8394_MAX_MEM = 9
Global Const APCI8394_MAX_IO = 20
Global Const APCI8394_MAX_IRQ = 7
Global Const APCI8394_MAX_DMA = 7
Type APCI8394RESOURCE
    dwNumMemWindows As Long                       ' EBhE
    dwMemBase(1 To APCI8394_MAX_MEM) As Long      ' EBhEJnAhX
    dwMemLength(1 To APCI8394_MAX_MEM) As Long    ' EBhE
    dwMemAttrib(1 To APCI8394_MAX_MEM) As Long    ' EBhE
    dwNumIOPorts As Long                          ' I/O|[g
    dwIOPortBase(1 To APCI8394_MAX_IO) As Long    ' I/O|[gJnAhX
    dwIOPortLength(1 To APCI8394_MAX_IO) As Long  ' I/O|[g
    dwNumIRQs As Long                             ' IRQ
    dwIRQRegisters(1 To APCI8394_MAX_IRQ) As Long ' IRQԍ
    dwIRQAttrib(1 To APCI8394_MAX_IRQ) As Long    ' IRQ
    dwNumDMAs As Long                             ' DMA`l
    dwDMALst(1 To APCI8394_MAX_DMA) As Long       ' DMA`l
    dwDMAAttrib(1 To APCI8394_MAX_DMA) As Long    ' DMA`l
    dwReserved1(1 To 3) As Long                   ' \
End Type
'-------------------------------------------------------------------
' HLS-C memory map
'-------------------------------------------------------------------
Global Const APCI8394_MEM_CMD =&H0000
Global Const APCI8394_MEM_DO =&H0080
Global Const APCI8394_MEM_DI =&H0100
Global Const APCI8394_MEM_C1 =&H0180
Global Const APCI8394_MEM_C2 =&H0200
Global Const APCI8394_MEM_C3 =&H0280
Global Const APCI8394_MEM_C4 =&H0300
Global Const APCI8394_MEM_C5 =&H0380
Global Const APCI8394_MEM_C6 =&H0400
Global Const APCI8394_MEM_DATA =&H0480

'-----------------------------------------------------------------
' API Functions
'-----------------------------------------------------------------
Public Declare Function Apci8394GetVersion Lib "Apci8394" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long
Public Declare Function Apci8394Create Lib "Apci8394" (ByRef pwLogSlot As Integer) As Long
Public Declare Function Apci8394Close Lib "Apci8394" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8394GetResource Lib "Apci8394" (ByVal wLogSlot As Integer, ByRef pres As APCI8394RESOURCE) As Long
Public Declare Function Apci8394GetLastError Lib "Apci8394" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8394Inpw Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wPort As Integer,ByRef pwData As Integer) As Long
Public Declare Function Apci8394Outpw Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wPort As Integer,ByVal wData As Integer) As Long
Public Declare Function Apci8394MemRead Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wAdr As Integer,ByRef pwData As Integer) As Long
Public Declare Function Apci8394MemWrite Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wAdr As Integer,ByVal wData As Integer) As Long
Public Declare Function Apci8394Initialize Lib "Apci8394" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8394Start Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wSNum As Integer) As Long
Public Declare Function Apci8394Stop Lib "Apci8394" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8394Dout Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wSNo As Integer,ByVal wData As Integer) As Long
Public Declare Function Apci8394Din Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wSNo As Integer,ByRef pwData As Integer) As Long
Public Declare Function Apci8394CntRead Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wSNo As Integer,ByVal wCntNo As Integer,ByRef pwData As Integer) As Long
Public Declare Function Apci8394DRegRead Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wSNo As Integer, ByRef pwData As Integer) As Long
Public Declare Function Apci8394CtrlWrite Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wSNo As Integer,ByVal wCmd As Integer) As Long
Public Declare Function Apci8394CtrlRead Lib "Apci8394" (ByVal wLogSlot As Integer,ByVal wSNo As Integer, ByRef pwValue AS Integer) As Long
