//===================================================================
// aPCI-8394 user application interface
//-------------------------------------------------------------------
// Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================

#ifndef __INC_APCI8394_H__
#define __INC_APCI8394_H__

#ifdef __cplusplus
extern "C" {
#endif

//-------------------------------------------------------------------
// \[X\
//-------------------------------------------------------------------
#define APCI8394_MAX_MEM				9
#define APCI8394_MAX_IO					20
#define APCI8394_MAX_IRQ				7
#define APCI8394_MAX_DMA				7

typedef struct {
	DWORD	dwNumMemWindows;							// Not used
	DWORD	dwMemBase		[APCI8394_MAX_MEM];			// Not used
	DWORD	dwMemLength		[APCI8394_MAX_MEM];			// Not used
	DWORD	dwMemAttrib		[APCI8394_MAX_MEM];			// Not used
	DWORD	dwNumIOPorts;								// Num IO ports
	DWORD	dwIOPortBase	[APCI8394_MAX_IO];			// I/O port base
	DWORD	dwIOPortLength	[APCI8394_MAX_IO];			// I/O port length
	DWORD	dwNumIRQs;									// Not used
	DWORD	dwIRQRegisters	[APCI8394_MAX_IRQ];			// Not used
	DWORD	dwIRQAttrib		[APCI8394_MAX_IRQ];			// Not used
	DWORD	dwNumDMAs;									// Not used
	DWORD	dwDMALst		[APCI8394_MAX_DMA];			// Not used
	DWORD	dwDMAAttrib		[APCI8394_MAX_DMA];			// Not used
	DWORD	dwReserved1		[3];						// Not used
} APCI8394RESOURCE, *PAPCI8394R;

//-------------------------------------------------------------------
// G[R[h
//-------------------------------------------------------------------
#define APCI8394_SUCCESS				0  // ُȂiIj
#define APCI8394_ERR_SYSTEM				1  // VXeG[
#define APCI8394_ERR_NO_DEVICE			2  // gp\ȃfoCX܂
#define APCI8394_ERR_IN_USE				3  // w̃foCX͎gpł
#define APCI8394_ERR_INVALID_SLOT		4  // Ș_Xbgł
#define APCI8394_ERR_RESOURCE			5  // \[XG[
#define APCI8394_ERR_INVALID_PORT		6  // sȃ|[gv
#define APCI8394_ERR_INVALID_ARG		7  // sȈv܂
#define APCI8394_ERR_PORT				8  // ȃ|[gł
#define APCI8394_ERR_INVALID_ADR		9  // ȃAhXł
#define APCI8394_ERR_BUSY				10 // ^pł

//-------------------------------------------------------------------
// ̑̒`
//-------------------------------------------------------------------
#define APCI8394_SLOT_AUTO				((WORD)~0U)
#define APCI8394_MAX_SLOTS				16

//-------------------------------------------------------------------
// gkr}bv
//-------------------------------------------------------------------
#define APCI8394_MEM_CMD				0x0000
#define APCI8394_MEM_DO					0x0080
#define APCI8394_MEM_DI					0x0100
#define APCI8394_MEM_C1					0x0180
#define APCI8394_MEM_C2					0x0200
#define APCI8394_MEM_C3					0x0280
#define APCI8394_MEM_C4					0x0300
#define APCI8394_MEM_C5					0x0380
#define APCI8394_MEM_C6					0x0400
#define APCI8394_MEM_DATA				0x0480

//-------------------------------------------------------------------
// R}hR[h
//-------------------------------------------------------------------
#define APCI8394_CMD_DI_READ			0
#define APCI8394_CMD_COUNTER1_READ		1
#define APCI8394_CMD_COUNTER2_READ		2
#define APCI8394_CMD_COUNTER3_READ		3
#define APCI8394_CMD_COUNTER4_READ		4
#define APCI8394_CMD_COUNTER5_READ		5
#define APCI8394_CMD_COUNTER6_READ		6
#define APCI8394_CMD_DATA_REG_READ		7
#define APCI8394_CMD_COUNTER1_CLEAR		9
#define APCI8394_CMD_COUNTER2_CLEAR		10
#define APCI8394_CMD_COUNTER3_CLEAR		11
#define APCI8394_CMD_COUNTER4_CLEAR		12
#define APCI8394_CMD_COUNTER5_CLEAR		13
#define APCI8394_CMD_COUNTER6_CLEAR		14

BOOL	WINAPI Apci8394GetVersion(PDWORD pdwDllVersion, PDWORD pdwDrvVersion);
BOOL	WINAPI Apci8394Create(PWORD pwLogSlot);
BOOL	WINAPI Apci8394Close(WORD wLogSlot);
BOOL	WINAPI Apci8394GetResource(WORD wLogSlot, PAPCI8394R pres);
BOOL	WINAPI Apci8394Inpw(WORD wLogSlot, WORD wPort, PWORD pwData);
BOOL	WINAPI Apci8394Outpw(WORD wLogSlot, WORD wPort, WORD wData);
BOOL	WINAPI Apci8394MemRead(WORD wLogSlot, WORD wAdr, PWORD pwData);
BOOL	WINAPI Apci8394MemWrite(WORD wLogSlot, WORD wAdr, WORD wData);
BOOL	WINAPI Apci8394Initialize(WORD wLogSlot);
BOOL	WINAPI Apci8394Start(WORD wLogSlot, WORD wSNum);
BOOL	WINAPI Apci8394Stop(WORD wLogSlot);
BOOL	WINAPI Apci8394Dout(WORD wLogSlot, WORD wSNo, WORD wData);
BOOL	WINAPI Apci8394Din(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL	WINAPI Apci8394CntRead(WORD wLogSlot, WORD wSNo, WORD wCntNo, PWORD pwData);
BOOL	WINAPI Apci8394DRegRead(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL	WINAPI Apci8394CtrlWrite(WORD wLogSlot, WORD wSNo, WORD wCmd);
BOOL	WINAPI Apci8394CtrlRead(WORD wLogSlot, WORD wSNo, PWORD pwValue);
DWORD	WINAPI Apci8394GetLastError(WORD wLogSlot);

#ifdef __cplusplus
}
#endif

#endif // __INC_APCI8394_H__
