/******************************************************************************/
/*	apci8394s.c																  */
/*																			  */
/*	aPCI-8394															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1999/06/02															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "apci8394w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR sz8394[] = _T("aPCI-8394");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDrvVer;
	BOOL			 bResult;		// 
	WORD			 wLogSlot;		// foCXi[
	APCI8394RESOURCE ri;			// \[X
	WORD			 wData;
	int				 i;
	WORD			 wSat;

	//-----------------------------------------------------------------
	// Apci8394.dll J
	//-----------------------------------------------------------------
	if (Apci8394wDllOpen() == FALSE)
	{
		ErrorMessage(APCI8394_SLOT_AUTO);
		return 1;			// apci8394.dll ̃[hɎs܂
	}

	//-----------------------------------------------------------------
	// o[W\
	//-----------------------------------------------------------------
	// aPCI-8394 DLL,Drṽo[Wԍ擾
	if (Apci8394wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(APCI8394_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

	//-----------------------------------------------------------------
	// foCX̎gp錾
	//-----------------------------------------------------------------
	wLogSlot = APCI8394_SLOT_AUTO;			// gp̃foCXT܂B
	bResult = Apci8394wCreate(&wLogSlot);	// ꍇA̎̃foCXi[܂B

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(APCI8394_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aPCI-8394 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	if (Apci8394wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("IO Address: %04xh-%04xh\n"),
					sz8394,
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1);

	ResultMessage(szbuf);

	///// gkr^pO /////

	//-----------------------------------------------------------------
	// TeCg
	//-----------------------------------------------------------------
	wSat = 3; // TeCgR

	wsprintf(szbuf, _T("TeCg %d ɐݒ肵܂"), wSat);

	ResultMessage(szbuf);

	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if (Apci8394wInitialize(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("foCX܂"));

	//-----------------------------------------------------------------
	// STeCgɑΉRg[GAɃ[ݒ
	//-----------------------------------------------------------------
	for (i = 1; i < wSat + 1; i++)
		if (Apci8394wCtrlWrite(wLogSlot, (WORD)i, 0) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

	ResultMessage(_T("Rg[GAɃ[ݒ肵܂"));

	//-----------------------------------------------------------------
	// ^p݁i^pJnj
	//-----------------------------------------------------------------
	if (Apci8394wStart(wLogSlot, wSat) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("^p %d łgkr^pJn܂"), wSat);

	ResultMessage(szbuf);

	///// ^p̏ /////

	//-----------------------------------------------------------------
	// TeCgԍPɑΉ DiGA̓ǂݍ
	//-----------------------------------------------------------------
	if (Apci8394wDin(wLogSlot, 1, &wData) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("TeCg %d ɑΉDiGA̒l = %Xh"), 1, wData);

	ResultMessage(szbuf);

	//-----------------------------------------------------------------
	// TeCgԓPɑΉ DoGAɒl
	//-----------------------------------------------------------------
	wData = 0xAAAA;

	if (Apci8394wDout(wLogSlot, 1, wData) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("TeCg %d ɑΉDoGA %Xh݂܂"), 1, wData);

	ResultMessage(szbuf);

	///// ^p~ /////

	//-----------------------------------------------------------------
	// ^p~
	//-----------------------------------------------------------------
	if (Apci8394wStop(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("gkr̉^p~܂"));

	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if (Apci8394wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-8394 Closed"));

	//-----------------------------------------------------------------
	// apci8394.dll ̎gpJ
	//-----------------------------------------------------------------
	if (Apci8394wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// apci8394.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci8394wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case APCI8394_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aPCI-8394 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
