/*****************************************************************************/
/*	apci8394w.c																 */
/*																			 */
/*	aPCI-8394															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1999/05/26															 */
/*																			 */
/*****************************************************************************/

#define STRICT

#include <windows.h>
#include <tchar.h>

#include "apci8394w.h"	// aPCI-8394

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Apci8394wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

static FARPROC pApci8394GetVersion;
static FARPROC pApci8394Create;
static FARPROC pApci8394Close;
static FARPROC pApci8394GetResource;
static FARPROC pApci8394Inpw;
static FARPROC pApci8394Outpw;
static FARPROC pApci8394MemRead;
static FARPROC pApci8394MemWrite;
static FARPROC pApci8394Initialize;
static FARPROC pApci8394Start;
static FARPROC pApci8394Stop;
static FARPROC pApci8394Dout;
static FARPROC pApci8394Din;
static FARPROC pApci8394CntRead;
static FARPROC pApci8394DRegRead;
static FARPROC pApci8394CtrlWrite;
static FARPROC pApci8394CtrlRead;
static FARPROC pApci8394GetLastError;


/*****************************************************************************/
/* 	  apci8394.dll[h												 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(APCI8394_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Apci8394wGetDllExportFunc() == FALSE)
	{
		Apci8394wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  apci8394.dllA[h											 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aPCI-8394 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aPCI-8394̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wCreate(PWORD pwLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Create)(pwLogSlot);
}

/*****************************************************************************/
/* 	  aPCI-8394̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot foCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wGetResource(WORD wLogSlot, PAPCI8394R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  [hŃ|[g璼ړ										 */
/* 	  wLogSlot foCX											 */
/*		  wPort	   |[gԍ												 */
/*		  pwData   ̓f[^i[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wInpw(WORD wLogSlot, WORD wPort, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Inpw)(wLogSlot, wPort, pwData);
}

/*****************************************************************************/
/* 	  [hŃ|[g֒ڏo											 */
/* 	  wLogSlot foCX											 */
/*		  wPort	   |[gԍ												 */
/*		  wData	   o̓f[^												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wOutpw(WORD wLogSlot, WORD wPort, WORD wData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Outpw)(wLogSlot, wPort, wData);
}

/*****************************************************************************/
/* 	  HLS ǂݍ												 */
/* 	  wLogSlot foCX											 */
/*		  wAdr	   AhX											 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wMemRead(WORD wLogSlot, WORD wAdr, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394MemRead)(wLogSlot, wAdr, pwData);
}

/*****************************************************************************/
/* 	  HLS 												 */
/* 	  wLogSlot foCX											 */
/*		  wAdr	   AhX											 */
/*		  wData	   ޒl												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wMemWrite(WORD wLogSlot, WORD wAdr, WORD wData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394MemWrite)(wLogSlot, wAdr, wData);
}

/*****************************************************************************/
/* 	  HLS 														 */
/* 	  wLogSlot	foCX										 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wInitialize(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Initialize)(wLogSlot);
}

/*****************************************************************************/
/* 	  HLS ʐMVXeJn												 */
/* 	  wLogSlot	foCX										 */
/*		  wSNum		^pTeCg									 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wStart(WORD wLogSlot, WORD wSNum)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Start)(wLogSlot, wSNum);
}

/*****************************************************************************/
/* 	  HLS ʐMVXe~												 */
/* 	  wLogSlot foCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wStop(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Stop)(wLogSlot);
}

/*****************************************************************************/
/* 	  Do GÃAhXɏݎs									 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  wData	   ޒl												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wDout(WORD wLogSlot, WORD wSNo, WORD wData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Dout)(wLogSlot, wSNo, wData);
}

/*****************************************************************************/
/* 	  Di GA̒lǂݍ											 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wDin(WORD wLogSlot, WORD wSNo, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394Din)(wLogSlot, wSNo, pwData);
}

/*****************************************************************************/
/* 	  JE^ n GA̒lǂݍ									 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  wCntNo   JE^ԍ(1`6)										 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wCntRead(WORD wLogSlot, WORD wSNo, WORD wCntNo, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394CntRead)(wLogSlot, wSNo, wCntNo, pwData);
}

/*****************************************************************************/
/* 	  f[^WX^GA̒lǂݍ								 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wDRegRead(WORD wLogSlot, WORD wSNo, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394DRegRead)(wLogSlot, wSNo, pwData);
}

/*****************************************************************************/
/* 	  Rg[GAɃR}h							 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  wCmd	   R}h													 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wCtrlWrite(WORD wLogSlot, WORD wSNo, WORD wCmd)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394CtrlWrite)(wLogSlot, wSNo, wCmd);
}

/*****************************************************************************/
/* 	  Rg[GAǂݍ										 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  pwValue  ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Apci8394wCtrlRead(WORD wLogSlot, WORD wSNo, PWORD pwValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8394CtrlRead)(wLogSlot, wSNo, pwValue);
}

/*****************************************************************************/
/* 	  aPCI-8394̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Apci8394wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return APCI8394_ERR_WRAPDLL;

	return (*pApci8394GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE s														 */
/*---------------------------------------------------------------------------*/
static BOOL Apci8394wGetDllExportFunc()
{
	// Apci8394GetVersion ̃AhX擾
	pApci8394GetVersion = GetProcAddress(hDLL, _T("Apci8394GetVersion"));
	if (pApci8394GetVersion == NULL)
		return FALSE;

	// Apci8394Create ̃AhX擾
	pApci8394Create = GetProcAddress(hDLL, _T("Apci8394Create"));
	if (pApci8394Create == NULL)
		return FALSE;

	// Apci8394Close ̃AhX擾
	pApci8394Close = GetProcAddress(hDLL, _T("Apci8394Close"));
	if (pApci8394Close == NULL)
		return FALSE;

	// Apci8394GetResource ̃AhX擾
	pApci8394GetResource = GetProcAddress(hDLL, _T("Apci8394GetResource"));
	if (pApci8394GetResource == NULL)
		return FALSE;

	// Apci8394Inpw ̃AhX擾
	pApci8394Inpw = GetProcAddress(hDLL, _T("Apci8394Inpw"));
	if (pApci8394Inpw == NULL)
		return FALSE;

	// Apci8394Outpw ̃AhX擾
	pApci8394Outpw = GetProcAddress(hDLL, _T("Apci8394Outpw"));
	if (pApci8394Outpw == NULL)
		return FALSE;

	// Apci8394MemRead ̃AhX擾
	pApci8394MemRead = GetProcAddress(hDLL, _T("Apci8394MemRead"));
	if (pApci8394MemRead == NULL)
		return FALSE;

	// Apci8394MemWrite ̃AhX擾
	pApci8394MemWrite = GetProcAddress(hDLL, _T("Apci8394MemWrite"));
	if (pApci8394MemWrite == NULL)
		return FALSE;

	// Apci8394Initialize ̃AhX擾
	pApci8394Initialize = GetProcAddress(hDLL, _T("Apci8394Initialize"));
	if (pApci8394Initialize == NULL)
		return FALSE;

	// Apci8394Start ̃AhX擾
	pApci8394Start = GetProcAddress(hDLL, _T("Apci8394Start"));
	if (pApci8394Start == NULL)
		return FALSE;

	// Apci8394Stop ̃AhX擾
	pApci8394Stop = GetProcAddress(hDLL, _T("Apci8394Stop"));
	if (pApci8394Stop == NULL)
		return FALSE;

	// Apci8394Dout ̃AhX擾
	pApci8394Dout = GetProcAddress(hDLL, _T("Apci8394Dout"));
	if (pApci8394Dout == NULL)
		return FALSE;

	// Apci8394Din ̃AhX擾
	pApci8394Din = GetProcAddress(hDLL, _T("Apci8394Din"));
	if (pApci8394Din == NULL)
		return FALSE;

	// Apci8394CntRead ̃AhX擾
	pApci8394CntRead = GetProcAddress(hDLL, _T("Apci8394CntRead"));
	if (pApci8394CntRead == NULL)
		return FALSE;

	// Apci8394DRegRead ̃AhX擾
	pApci8394DRegRead = GetProcAddress(hDLL, _T("Apci8394DRegRead"));
	if (pApci8394DRegRead == NULL)
		return FALSE;

	// Apci8394CtrlWrite ̃AhX擾
	pApci8394CtrlWrite = GetProcAddress(hDLL, _T("Apci8394CtrlWrite"));
	if (pApci8394CtrlWrite == NULL)
		return FALSE;

	// Apci8394CtrlRead ̃AhX擾
	pApci8394CtrlRead = GetProcAddress(hDLL, _T("Apci8394CtrlRead"));
	if (pApci8394CtrlRead == NULL)
		return FALSE;

	// Apci8394GetLastError ̃AhX擾
	pApci8394GetLastError = GetProcAddress(hDLL, _T("Apci8394GetLastError"));
	if (pApci8394GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
